#ifndef CICOMPDIR_H
#define CICOMPDIR_H

//$Id: CICompDir.h,v 1.6 2003/11/16 20:48:07 markus Rel $

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <string>

#include <CORBA.h>

#include <YGP/DirSrch.h>
#include <CGP/CIDirSrch.h>

#include "CompDir.h"
#include "CCompDir.h"


class CICompareDirs : virtual public CCompareDirs_skel,
		      virtual public CompareDirs {
 public:
   virtual void compare ();
   
   virtual CORBA::Boolean getResult (CFile_out original,
				     CFile_out compare,
				     CORBA::ULong_out status);

   virtual void addOption (CORBA::ULong option);
   virtual void removeOption (CORBA::ULong option);
   virtual void toggleOption (CORBA::ULong option);

   virtual void setOriginalDir (CDirectorySearch_ptr dir);
   virtual void setCompareDir  (CDirectorySearch_ptr dir);

   virtual CORBA::Boolean setBeginTime (const char* time);
   virtual CORBA::Boolean setEndTime   (const char* time);

   virtual void addIncludeFiles (const char* incl);
   virtual void addExcludeFiles (const char* excl);
   virtual void addIncludeDirs (const char* incl);
   virtual void addExcludeDirs (const char* excl);
   virtual void clearFiles ();
   virtual void clearDirectories ();

   virtual ::CDirectorySearch_ptr makeSearchObject (const char* dir);

   CICompareDirs ();

                      protected:
   // Callback for differing files
   virtual void showFile (const Status diff, const YGP::File* pFileOrig,
			  const YGP::File* pFileComp = NULL);

 private:
    CFile* pOrig;
    CFile* pComp;
    CORBA::ULong _status;
};

#endif // CICOMPDIR
